# coding: utf-8

"""
    FINBOURNE Candela Platform Web API

    FINBOURNE Technology  # noqa: E501

    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, Dict, Optional
from pydantic.v1 import BaseModel, Field, StrictBool, StrictStr
from finbourne_candela.models.tool_obj import ToolObj

class UseTool(BaseModel):
    """
    Class representing a tool use state. Tools are bit of code that take intents and perform an action. This lets circuits call out to external systems or local software.  # noqa: E501
    """
    node_id: Optional[StrictStr] = None
    node_type: Optional[StrictStr] = None
    as_block: Optional[StrictBool] = False
    child_id: Optional[StrictStr] = None
    intent_id: StrictStr = Field(...)
    tool_obj: ToolObj = Field(...)
    additional_properties: Dict[str, Any] = {}
    __properties = ["node_id", "node_type", "as_block", "child_id", "intent_id", "tool_obj"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def __str__(self):
        """For `print` and `pprint`"""
        return pprint.pformat(self.dict(by_alias=False))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> UseTool:
        """Create an instance of UseTool from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                            "additional_properties"
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of tool_obj
        if self.tool_obj:
            _dict['tool_obj'] = self.tool_obj.to_dict()
        # puts key-value pairs in additional_properties in the top level
        if self.additional_properties is not None:
            for _key, _value in self.additional_properties.items():
                _dict[_key] = _value

        # set to None if node_id (nullable) is None
        # and __fields_set__ contains the field
        if self.node_id is None and "node_id" in self.__fields_set__:
            _dict['node_id'] = None

        # set to None if node_type (nullable) is None
        # and __fields_set__ contains the field
        if self.node_type is None and "node_type" in self.__fields_set__:
            _dict['node_type'] = None

        # set to None if child_id (nullable) is None
        # and __fields_set__ contains the field
        if self.child_id is None and "child_id" in self.__fields_set__:
            _dict['child_id'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> UseTool:
        """Create an instance of UseTool from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return UseTool.parse_obj(obj)

        _obj = UseTool.parse_obj({
            "node_id": obj.get("node_id"),
            "node_type": obj.get("node_type"),
            "as_block": obj.get("as_block") if obj.get("as_block") is not None else False,
            "child_id": obj.get("child_id"),
            "intent_id": obj.get("intent_id"),
            "tool_obj": ToolObj.from_dict(obj.get("tool_obj")) if obj.get("tool_obj") is not None else None
        })
        # store additional fields in additional_properties
        for _key in obj.keys():
            if _key not in cls.__properties:
                _obj.additional_properties[_key] = obj.get(_key)

        return _obj
